Index: drivers/dahdi/dahdi_echocan_kb1.c
===================================================================
--- drivers/dahdi/dahdi_echocan_kb1.c	(revision 7107)
+++ drivers/dahdi/dahdi_echocan_kb1.c	(working copy)
@@ -31,6 +31,18 @@
  * this program for more details.
  */
 
+#if defined(__FreeBSD__)
+#include <sys/param.h>
+#include <sys/types.h>
+#include <sys/conf.h>
+#include <sys/ctype.h>
+#include <sys/libkern.h>
+#include <sys/module.h>
+
+#define module_printk(level, fmt, args...) printf(fmt, ## args)
+#define debug_printk(level, fmt, args...) if (debug >= level) printf("%s: " fmt, __FUNCTION__, ## args)
+
+#else /* !__FreeBSD__ */
 #include <linux/kernel.h>
 #include <linux/slab.h>
 #include <linux/errno.h>
@@ -39,14 +51,15 @@
 #include <linux/ctype.h>
 #include <linux/moduleparam.h>
 
+#define module_printk(level, fmt, args...) printk(level "%s: " fmt, THIS_MODULE->name, ## args)
+#define debug_printk(level, fmt, args...) if (debug >= level) printk(KERN_DEBUG "%s (%s): " fmt, THIS_MODULE->name, __FUNCTION__, ## args)
+#endif /* !__FreeBSD__ */
+
 #include <dahdi/kernel.h>
 
 static int debug;
 static int aggressive;
 
-#define module_printk(level, fmt, args...) printk(level "%s: " fmt, THIS_MODULE->name, ## args)
-#define debug_printk(level, fmt, args...) if (debug >= level) printk(KERN_DEBUG "%s (%s): " fmt, THIS_MODULE->name, __FUNCTION__, ## args)
-
 /* Uncomment to provide summary statistics for overall echo can performance every 4000 samples */ 
 /* #define MEC2_STATS 4000 */
 
@@ -151,8 +164,10 @@
 
 static const struct dahdi_echocan_factory my_factory = {
 	.name = "KB1",
+	.echocan_create = echo_can_create,
+#if !defined(__FreeBSD__)
 	.owner = THIS_MODULE,
-	.echocan_create = echo_can_create,
+#endif
 };
 
 static const struct dahdi_echocan_features my_features = {
@@ -270,7 +285,7 @@
 	unsigned long tmp;
 
 	/* Double-word align past end of state */
-	ptr += sizeof(*pvt);
+	ptr = (char *) ptr + sizeof(*pvt);
 	tmp = (unsigned long)ptr;
 	tmp += 3;
 	tmp &= ~3L;
@@ -282,20 +297,20 @@
   
 	/* Allocate coefficient memory */
 	pvt->a_i = ptr;
-	ptr += (sizeof(int) * pvt->N_d);
+	ptr = (char *) ptr + (sizeof(int) * pvt->N_d);
 	pvt->a_s = ptr;
-	ptr += (sizeof(short) * pvt->N_d);
+	ptr = (char *) ptr + (sizeof(short) * pvt->N_d);
 
 	/* Reset Y circular buffer (short version) */
 	init_cb_s(&pvt->y_s, maxy, ptr);
-	ptr += (sizeof(short) * (maxy) * 2);
+	ptr = (char *) ptr + (sizeof(short) * (maxy) * 2);
   
 	/* Reset Sigma circular buffer (short version for FIR filter) */
 	init_cb_s(&pvt->s_s, (1 << DEFAULT_ALPHA_ST_I), ptr);
-	ptr += (sizeof(short) * (1 << DEFAULT_ALPHA_ST_I) * 2);
+	ptr = (char *) ptr + (sizeof(short) * (1 << DEFAULT_ALPHA_ST_I) * 2);
 
 	init_cb_s(&pvt->u_s, maxu, ptr);
-	ptr += (sizeof(short) * maxu * 2);
+	ptr = (char *) ptr + (sizeof(short) * maxu * 2);
 
 	/* Allocate a buffer for the reference signal power computation */
 	init_cb_s(&pvt->y_tilde_s, pvt->N_d, ptr);
@@ -658,7 +673,7 @@
 
 	pvt = kzalloc(size, GFP_KERNEL);
 	if (!pvt)
-		return -ENOMEM;
+		return _RETVAL(ENOMEM);
 
 	pvt->dahdi.ops = &my_ops;
 
@@ -674,7 +689,7 @@
 			printk(KERN_WARNING "Unknown parameter supplied to KB1 echo canceler: '%s'\n", p[x].name);
 			kfree(pvt);
 
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		}
 	}
 
@@ -719,12 +734,10 @@
 {
 	if (dahdi_register_echocan_factory(&my_factory)) {
 		module_printk(KERN_ERR, "could not register with DAHDI core\n");
-
-		return -EPERM;
+		return _RETVAL(EPERM);
 	}
 
 	module_printk(KERN_NOTICE, "Registered echo canceler '%s'\n", my_factory.name);
-
 	return 0;
 }
 
@@ -733,6 +746,26 @@
 	dahdi_unregister_echocan_factory(&my_factory);
 }
 
+#if defined(__FreeBSD__)
+static int
+echocan_kb1_modevent(module_t mod __unused, int type, void *data __unused)
+{
+	switch (type) {
+	case MOD_LOAD:
+		return mod_init();
+	case MOD_UNLOAD:
+		mod_exit();
+		return 0;
+	default:
+		return _RETVAL(EOPNOTSUPP);
+	}
+}
+
+DEV_MODULE(dahdi_echocan_kb1, echocan_kb1_modevent, NULL);
+MODULE_VERSION(dahdi_echocan_kb1, 1);
+MODULE_DEPEND(dahdi_echocan_kb1, dahdi, 1, 1, 1);
+
+#else /* !__FreeBSD__ */
 module_param(debug, int, S_IRUGO | S_IWUSR);
 module_param(aggressive, int, S_IRUGO | S_IWUSR);
 
@@ -742,3 +775,4 @@
 
 module_init(mod_init);
 module_exit(mod_exit);
+#endif /* !__FreeBSD__ */
Index: drivers/dahdi/ecdis.h
===================================================================
--- drivers/dahdi/ecdis.h	(revision 7107)
+++ drivers/dahdi/ecdis.h	(working copy)
@@ -29,7 +29,9 @@
 #include "biquad.h"
 
 #define FALSE 0
+#ifndef TRUE
 #define TRUE (!FALSE)
+#endif
 
 static inline void echo_can_disable_detector_init (echo_can_disable_detector_state_t *det)
 {
Index: drivers/dahdi/dahdi_echocan_sec2.c
===================================================================
--- drivers/dahdi/dahdi_echocan_sec2.c	(revision 7107)
+++ drivers/dahdi/dahdi_echocan_sec2.c	(working copy)
@@ -35,6 +35,18 @@
    Improve double talk detector (iterative!)
 */
 
+#if defined(__FreeBSD__)
+#include <sys/param.h>
+#include <sys/types.h>
+#include <sys/conf.h>
+#include <sys/ctype.h>
+#include <sys/libkern.h>
+#include <sys/module.h>
+
+#define module_printk(level, fmt, args...) printf(fmt, ## args)
+#define debug_printk(level, fmt, args...) if (debug >= level) printf("%s: " fmt, __FUNCTION__, ## args)
+
+#else /* !__FreeBSD__ */
 #include <linux/kernel.h>
 #include <linux/slab.h>
 #include <linux/errno.h>
@@ -43,13 +55,14 @@
 #include <linux/ctype.h>
 #include <linux/moduleparam.h>
 
+#define module_printk(level, fmt, args...) printk(level "%s: " fmt, THIS_MODULE->name, ## args)
+#define debug_printk(level, fmt, args...) if (debug >= level) printk(KERN_DEBUG "%s (%s): " fmt, THIS_MODULE->name, __FUNCTION__, ## args)
+#endif /* !__FreeBSD__ */
+
 #include <dahdi/kernel.h>
 
 static int debug;
 
-#define module_printk(level, fmt, args...) printk(level "%s: " fmt, THIS_MODULE->name, ## args)
-#define debug_printk(level, fmt, args...) if (debug >= level) printk(KERN_DEBUG "%s (%s): " fmt, THIS_MODULE->name, __FUNCTION__, ## args)
-
 #include "fir.h"
 
 #ifndef NULL
@@ -84,8 +97,10 @@
 
 static const struct dahdi_echocan_factory my_factory = {
 	.name = "SEC2",
+	.echocan_create = echo_can_create,
+#if !defined(__FreeBSD__)
 	.owner = THIS_MODULE,
-	.echocan_create = echo_can_create,
+#endif
 };
 
 static const struct dahdi_echocan_ops my_ops = {
@@ -135,20 +150,19 @@
 
 	if (ecp->param_count > 0) {
 		printk(KERN_WARNING "SEC2 does not support parameters; failing request\n");
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 	}
 
 	size = sizeof(*pvt) + ecp->tap_length * sizeof(int32_t) + ecp->tap_length * 3 * sizeof(int16_t);
-	
 	pvt = kzalloc(size, GFP_KERNEL);
 	if (!pvt)
-		return -ENOMEM;
+		return _RETVAL(ENOMEM);
 
 	pvt->dahdi.ops = &my_ops;
 
 	if (ecp->param_count > 0) {
 		printk(KERN_WARNING "SEC-2 echo canceler does not support parameters; failing request\n");
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 	}
 
 	pvt->taps = ecp->tap_length;
@@ -328,7 +342,7 @@
 	if (dahdi_register_echocan_factory(&my_factory)) {
 		module_printk(KERN_ERR, "could not register with DAHDI core\n");
 
-		return -EPERM;
+		return _RETVAL(EPERM);
 	}
 
 	module_printk(KERN_NOTICE, "Registered echo canceler '%s'\n", my_factory.name);
@@ -341,6 +355,26 @@
 	dahdi_unregister_echocan_factory(&my_factory);
 }
 
+#if defined(__FreeBSD__)
+static int
+echocan_sec2_modevent(module_t mod __unused, int type, void *data __unused)
+{
+	switch (type) {
+	case MOD_LOAD:
+		return mod_init();
+	case MOD_UNLOAD:
+		mod_exit();
+		return 0;
+	default:
+		return _RETVAL(EOPNOTSUPP);
+	}
+}
+
+DEV_MODULE(dahdi_echocan_sec2, echocan_sec2_modevent, NULL);
+MODULE_VERSION(dahdi_echocan_sec2, 1);
+MODULE_DEPEND(dahdi_echocan_sec2, dahdi, 1, 1, 1);
+
+#else /* !__FreeBSD__ */
 module_param(debug, int, S_IRUGO | S_IWUSR);
 
 MODULE_DESCRIPTION("DAHDI 'SEC2' Echo Canceler");
@@ -349,3 +383,4 @@
 
 module_init(mod_init);
 module_exit(mod_exit);
+#endif /* !__FreeBSD__ */
Index: drivers/dahdi/wcb4xxp/wcb4xxp.h
===================================================================
--- drivers/dahdi/wcb4xxp/wcb4xxp.h	(revision 7107)
+++ drivers/dahdi/wcb4xxp/wcb4xxp.h	(working copy)
@@ -6,7 +6,9 @@
 #ifndef _B4XX_H_
 #define _B4XX_H_
 
+#if !defined(__FreeBSD__)
 #include <linux/ioctl.h>
+#endif
 
 #define HFC_NR_FIFOS	32
 #define HFC_ZMIN	0x80			/* from datasheet */
@@ -432,11 +434,25 @@
 	char *variety;
 	int chiprev;				/* revision of HFC-4S */
 
+#if defined(__FreeBSD__)
+	device_t dev;				/* device */
+
+	struct resource *io_res;		/* resource for I/O range */
+	int io_rid;
+
+	struct resource *mem_res;		/* resource for memory range */
+	int mem_rid;
+
+	struct resource *irq_res;		/* resource for irq */
+	int irq_rid;
+	void *irq_handle;
+#else
 	struct pci_dev *pdev;			/* Pointer to PCI device */
 	struct device *dev;			/* kernel dev struct (from pdev->dev) */
 	void __iomem *addr;			/* I/O address (memory mapped) */
 	void __iomem *ioaddr;			/* I/O address (index based) */
 	int irq;				/* IRQ used by device */
+#endif
 
 	spinlock_t reglock;			/* lock for all register accesses */
 	spinlock_t seqlock;			/* lock for "sequence" accesses that must be ordered */
@@ -473,7 +489,9 @@
 
 	/* Flags for our bottom half */
 	unsigned int shutdown;			/* 1=bottom half doesn't process anything, just returns */
+#if !defined(__FreeBSD__)
 	struct tasklet_struct b4xxp_tlet;
+#endif
 };
 
 /* CPLD access bits */
@@ -501,7 +519,7 @@
 #define LED_RED		(1)
 #define LED_GREEN	(2)
 
-#define get_F(f1, f2, flen) {				\
+#define get_F(b4, f1, f2, flen) {			\
 	f1 = hfc_readcounter8(b4, A_F1);		\
 	f2 = hfc_readcounter8(b4, A_F2);		\
 	flen = f1 - f2;					\
@@ -510,7 +528,7 @@
 		flen += (HFC_FMAX - HFC_FMIN) + 1;	\
 	}
 
-#define get_Z(z1, z2, zlen) {				\
+#define get_Z(b4, z1, z2, zlen) {			\
 	z1 = hfc_readcounter16(b4, A_Z1);		\
 	z2 = hfc_readcounter16(b4, A_Z2);		\
 	zlen = z1 - z2;					\
@@ -519,7 +537,14 @@
 		zlen += (HFC_ZMAX - HFC_ZMIN) + 1;	\
 	}
 
+#if defined(__FreeBSD__)
+#define flush_pci()	(void) bus_space_read_1(	\
+	rman_get_bustag(b4->mem_res),			\
+	rman_get_bushandle(b4->mem_res),		\
+	R_STATUS)
+#else
 #define flush_pci()	(void)ioread8(b4->addr + R_STATUS)
+#endif
 
 #endif	/* __KERNEL__ */
 #endif	/* _B4XX_H_ */
